import { cx, css } from '@emotion/css';
import React__default from 'react';
import '../../themes/ThemeContext.js';
import '@grafana/data';
import { stylesFactory } from '../../themes/stylesFactory.js';
import '@emotion/react';
import 'tinycolor2';

const FullWidthButtonContainer = ({ className, children }) => {
  const styles = getStyles();
  return /* @__PURE__ */ React__default.createElement("div", { className: cx(styles, className) }, children);
};
const getStyles = stylesFactory(() => {
  return css({
    display: "flex",
    button: {
      flexGrow: 1,
      justifyContent: "center"
    },
    "> *": {
      flexGrow: 1
    },
    label: {
      flexGrow: 1,
      textAlign: "center"
    }
  });
});

export { FullWidthButtonContainer };
//# sourceMappingURL=FullWidthButtonContainer.js.map
